Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/CopyTargetList/FrmNewOrContinueCopy.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/CopyTargetList/FrmNewOrContinueCopy.cs	(revision 82)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/CopyTargetList/FrmNewOrContinueCopy.cs	(revision 83)
@@ -34,12 +34,12 @@
             ConstructionPerson,
             ConstructionPeriod,
             radioButton1,
+            radioButton2,
+            radioButton3,
+            radioButton4,
             ConstructionCode1,
-            radioButton2,
             ConstructionCode2,
-            radioButton3,
             ConstructionCode3,
-            radioButton4,
             ConstructionCode4,
         }
         /// <summary>
@@ -69,6 +69,12 @@
         /// 新規工事番号取得
         /// </summary>
         private bool m_NewConstruction = false;
+
+        /// <summary>
+        /// 工事基本情報
+        /// </summary>
+        private ConstructionBaseInfo m_BaseRec = new ConstructionBaseInfo();
+
         #endregion
 
         #region プロパティ
@@ -174,8 +180,8 @@
             this.Close();
         }
         #endregion
-        
-        #region ラジオボタン
+
+        #region ラジオボタンの変更
         /// <summary>
         /// チェックボタンの変更
         /// </summary>
@@ -183,48 +189,61 @@
         /// <param name="e"></param>
         private void radioButton1_CheckedChanged(object sender, EventArgs e)
         {
-            if (radioButton1.Checked)
+            try
             {
-                tableLayoutPanel3.Visible = true;
-                lblNextMessage.Visible = false;
+                // ONのみ処理をおこなう
+                RadioButton ChgButton = (RadioButton)sender;
+                if (!ChgButton.Checked) return;
+
+                int DispCtrlCnt = 0;
+                for (int i = (int)Dispcount.radioButton1; i <= (int)Dispcount.radioButton4; i++)
+                {
+                    if (ChgButton == m_dispControl[i])
+                    {
+                        DispCtrlCnt = (i - (int)Dispcount.radioButton1) + (int)Dispcount.ConstructionCode1;
+                        continue;
+                    }
+                    RadioButton rdbwork = (RadioButton)m_dispControl[i];
+                    rdbwork.Checked = false;
+                }
+
+                if (radioButton1.Checked)
+                {
+                    tableLayoutPanel3.Visible = true;
+                    lblNextMessage.Visible = false;
+                }
+                else if (radioButton2.Checked)
+                {
+                    tableLayoutPanel3.Visible = false;
+                    lblNextMessage.Visible = true;
+                }
+                else if (radioButton3.Checked)
+                {
+                    tableLayoutPanel3.Visible = false;
+                    lblNextMessage.Visible = true;
+                }
+                else if (radioButton4.Checked)
+                {
+                    tableLayoutPanel3.Visible = false;
+                    lblNextMessage.Visible = true;
+                }
+
+                // 工事番号コントロールの表示
+                for (int i = (int)Dispcount.ConstructionCode1; i <= (int)Dispcount.ConstructionCode4; i++)
+                {
+                    if (i == DispCtrlCnt)
+                        m_dispControl[(int)Dispcount.ConstructionCode1].Visible = true;
+                    else
+                        m_dispControl[(int)Dispcount.ConstructionCode1].Visible = false;
+                }
+
                 // 工事番号の表示
-                m_dispControl[(int)Dispcount.ConstructionCode1].Visible = true;
-                m_dispControl[(int)Dispcount.ConstructionCode2].Visible = false;
-                m_dispControl[(int)Dispcount.ConstructionCode3].Visible = false;
-                m_dispControl[(int)Dispcount.ConstructionCode4].Visible = false;
+                SetConstructionCode();
             }
-            else if (radioButton2.Checked)
+            catch (Exception ex)
             {
-                tableLayoutPanel3.Visible = false;
-                lblNextMessage.Visible = true;
-                // 工事番号の表示
-                m_dispControl[(int)Dispcount.ConstructionCode1].Visible = false;
-                m_dispControl[(int)Dispcount.ConstructionCode2].Visible = true;
-                m_dispControl[(int)Dispcount.ConstructionCode3].Visible = false;
-                m_dispControl[(int)Dispcount.ConstructionCode4].Visible = false;
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
             }
-            else if (radioButton3.Checked)
-            {
-                tableLayoutPanel3.Visible = false;
-                lblNextMessage.Visible = true;
-                // 工事番号の表示
-                m_dispControl[(int)Dispcount.ConstructionCode1].Visible = false;
-                m_dispControl[(int)Dispcount.ConstructionCode2].Visible = false;
-                m_dispControl[(int)Dispcount.ConstructionCode3].Visible = true;
-                m_dispControl[(int)Dispcount.ConstructionCode4].Visible = false;
-            }
-            else if (radioButton4.Checked)
-            {
-                tableLayoutPanel3.Visible = false;
-                lblNextMessage.Visible = true;
-                // 工事番号の表示
-                m_dispControl[(int)Dispcount.ConstructionCode1].Visible = false;
-                m_dispControl[(int)Dispcount.ConstructionCode2].Visible = false;
-                m_dispControl[(int)Dispcount.ConstructionCode3].Visible = false;
-                m_dispControl[(int)Dispcount.ConstructionCode4].Visible = true;
-            }
-            // 工事番号の表示
-            SetConstructionCode();
         }
 
         #endregion
@@ -438,8 +457,11 @@
 
                 // 工事基本情報取得
                 string strSQL = cbDB.CreatePrimarykeyString(m_ConstructionCode);
-                ConstructionBaseInfo cbRec = new ConstructionBaseInfo();
-                if (!cbDB.SelectAction(strSQL, ref cbRec)) return false;
+                if (!cbDB.SelectAction(strSQL, ref m_BaseRec))
+                {
+                    MessageBox.Show("工事基本情報が存在しません。", "データ存在エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
 
                 // 積算見積データ取得（見積データが無くてもコピーを行う 2016/07/19）
                 //strSQL = edDB.CreatePrimarykeyString(m_ConstructionCode);
@@ -454,17 +476,27 @@
                 toolTip1.SetToolTip(m_dispControl[(int)Dispcount.ConstructionName], cbdRec.DetailString);
 
                 // 担当者表示
-                m_dispControl[(int)Dispcount.SalesPerson].Text = GetPersonName(cbRec.SalesPersonCode);
+                m_dispControl[(int)Dispcount.SalesPerson].Text = GetPersonName(m_BaseRec.SalesPersonCode);
                 toolTip1.SetToolTip(m_dispControl[(int)Dispcount.SalesPerson], m_dispControl[(int)Dispcount.SalesPerson].Text);
-                cmbSalesPerson.SelectedValue = cbRec.SalesPersonCode;
+                cmbSalesPerson.SelectedValue = m_BaseRec.SalesPersonCode;
 
-                m_dispControl[(int)Dispcount.ConstructionPerson].Text = GetPersonName(cbRec.ConstructionPersonCode);
+                m_dispControl[(int)Dispcount.ConstructionPerson].Text = GetPersonName(m_BaseRec.ConstructionPersonCode);
                 toolTip1.SetToolTip(m_dispControl[(int)Dispcount.ConstructionPerson], m_dispControl[(int)Dispcount.ConstructionPerson].Text);
-                cmbConstructionPerson.SelectedValue = cbRec.ConstructionPersonCode;
+                cmbConstructionPerson.SelectedValue = m_BaseRec.ConstructionPersonCode;
 
                 // 工事番号表示
                 SetConstructionCode();
 
+                // 積算見積データ取得（見積データが無い場合は工事情報のみをコピーする 2017/03/16）
+                strSQL = edDB.CreatePrimarykeyString(m_ConstructionCode);
+                EstimateData edRec = new EstimateData();
+                if (!edDB.SelectAction(strSQL, ref edRec))
+                {
+                    radioButton1.Text = "工事情報のみをコピー【同一工事として作成】";
+                    panel3.Enabled = false;
+                    panel5.Enabled = false;
+                }
+
                 return bRet;
             }
             catch (Exception ex)
@@ -548,17 +580,12 @@
                     return;
                 }
 
-                // 現在データを取得する
-                string strExistsData = cbDB.CreatePrimarykeyString(m_ConstructionCode);
-                ConstructionBaseInfo BaseRec = new ConstructionBaseInfo();
-                if (!cbDB.SelectAction(strExistsData, ref BaseRec)) return;
-
                 // ----- 見積データのみコピー・工事情報のみコピー
                 int PeriodValue = 0;
                 if (CommonMotions.SystemMasterData.ConstructionNoBase == (int)CommonDefine.SystemConstructionNoBase.BusinessPeriod)
-                    PeriodValue = BaseRec.ConstructionPeriod;
+                    PeriodValue = m_BaseRec.ConstructionPeriod;
                 else
-                    PeriodValue = BaseRec.ConstructionYear;
+                    PeriodValue = m_BaseRec.ConstructionYear;
 
                 // 新規工事番号の表示
                 int ConstructionCode = cbDB.CreateNewCounstructionCode(PeriodValue);
@@ -708,6 +735,7 @@
             IOEstimateDataBody DB4 = new IOEstimateDataBody();                          // 積算見積ボディ
             IOEstimateDataDetail DB5 = new IOEstimateDataDetail();                      // 積算見積明細
             IOConstructionProgressDate DB6 = new IOConstructionProgressDate();          // 案件進捗日付データ
+            IOConstructionLink DB7 = new IOConstructionLink();                          // 工事リンク情報
             try
             {
                 int iToCode = 0;
@@ -735,6 +763,7 @@
                 DB4.connect(); DB4.beginTran();
                 DB5.connect(); DB5.beginTran();
                 DB6.connect(); DB6.beginTran();
+                DB7.connect(); DB7.beginTran();
 
                 // デフォルトは新規工事にしておく
                 m_NewConstruction = true;
@@ -750,7 +779,7 @@
                         DB5.rollback();
                         return false;
                     }
-
+                    // 工事基本情報コピー
                     if (!RecordCopyTypeA(m_ConstructionCode, iToCode, DB1, DB2))
                     {
                         DB1.rollback();
@@ -781,6 +810,17 @@
                         return false;
                     }
 
+                    // 工事リンク情報作成処理
+                    if(!CreateConstructionLink(iToCode,  DB7))
+                    {
+                        DB1.rollback();
+                        DB2.rollback();
+                        DB3.rollback();
+                        DB4.rollback();
+                        DB5.rollback();
+                        DB7.rollback();
+                        return false;
+                    }
                     // 継続案件の場合は新規工事フラグを落とす
                     m_NewConstruction = false;
                 }
@@ -795,11 +835,11 @@
                         DB5.rollback();
                         return false;
                     }
-
                 }
                 // ----- 工事基本情報コピー
                 else if (radioButton3.Checked)
                 {
+                    // 工事基本情報コピー
                     if (!RecordCopyTypeA(m_ConstructionCode, iToCode, DB1, DB2))
                     {
                         DB1.rollback();
@@ -841,7 +881,7 @@
                         DB5.rollback();
                         return false;
                     }
-
+                    // 工事基本情報コピー
                     if (!RecordCopyTypeA(m_ConstructionCode, iToCode, DB1, DB2))
                     {
                         DB1.rollback();
@@ -882,6 +922,7 @@
                     DB4.rollback();
                     DB5.rollback();
                     DB6.rollback();
+                    DB7.rollback();
                     return false;
                 }
 
@@ -894,6 +935,7 @@
                 DB4.commit();
                 DB5.commit();
                 DB6.commit();
+                DB7.commit();
 
                 return true;
             }
@@ -910,6 +952,7 @@
                 DB4.close(); DB4 = null;
                 DB5.close(); DB5 = null;
                 DB6.close(); DB6 = null;
+                DB7.close(); DB7 = null;
             }
         }
         #endregion
@@ -926,7 +969,11 @@
                 // 工事基本情報の設定
                 string strSQL = cbDB.CreatePrimarykeyString(ToCode);
                 ConstructionBaseInfo cbRec = new ConstructionBaseInfo();
-                if (!cbDB.SelectAction(strSQL, ref cbRec, false)) return false;
+                if (!cbDB.SelectAction(strSQL, ref cbRec, false))
+                {
+                    MessageBox.Show("工事基本情報が存在しません。", "データ存在エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
 
                 // 営業期・工事年度を更新する
                 int iPeriod = 0;
@@ -1003,8 +1050,19 @@
                     cbRec.ConstructionPersonCode = CommonMotions.cnvInt(cmbConstructionPerson.SelectedValue.ToString());
                 }
 
+                // 結合工事は通常の工事に変更する
+                if (cbRec.JoinFlg != 0)
+                {
+                    cbRec.JoinFlg = 0;
+                    cbRec.TyingFlg = 0;
+                }
+
                 // 更新処理
-                if (!cbDB.UpdateAction(strSQL, cbRec, false)) return false;
+                if (!cbDB.UpdateAction(strSQL, cbRec, false))
+                {
+                    MessageBox.Show("工事基本情報、更新に失敗しました。", "コピー処理エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
 
                 return true;
             }
@@ -1028,7 +1086,11 @@
                 // 工事基本情報明細の設定
                 string strSQL = cbidDB.CreatePrimarykeyString(ToCode, (int)ConstructionBaseInfoDetail.DetailDataNo.ConstructionName);
                 ConstructionBaseInfoDetail cbidRec = new ConstructionBaseInfoDetail();
-                if (!cbidDB.SelectAction(strSQL, ref cbidRec, false)) return false;
+                if (!cbidDB.SelectAction(strSQL, ref cbidRec, false))
+                {
+                    MessageBox.Show("工事基本情報明細が存在しません。", "データ存在エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
 
                 // 工事名を更新する
                 if (cbidRec.DetailString.Length < s_ConstructionNameLength - 2)
@@ -1047,12 +1109,16 @@
                         }
                     }
 
-                    int CodeLower = (ToCode % 100);
+                    int CodeLower = (ToCode % 100) - 1;
                     cbidRec.DetailString = cbidRec.DetailString + CodeLower.ToString();
                 }
 
                 // 更新処理
-                if (!cbidDB.UpdateAction(strSQL, cbidRec, false)) return false;
+                if (!cbidDB.UpdateAction(strSQL, cbidRec, false))
+                {
+                    MessageBox.Show("工事基本情報明細、更新に失敗しました。", "コピー処理エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
 
                 return true;
             }
@@ -1081,8 +1147,16 @@
                 DB1.DeleteAction(strSQL, false);
                 DB2.DeleteAction(strSQL, false);
 
-                if (!DB1.RecordCopyAction(FromCode, ToCode, false)) return false;
-                if (!DB2.RecordCopyAction(FromCode, ToCode, false)) return false;
+                if (!DB1.RecordCopyAction(FromCode, ToCode, false))
+                {
+                    MessageBox.Show("工事基本情報、作成に失敗しました。", "コピー処理エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+                if (!DB2.RecordCopyAction(FromCode, ToCode, false))
+                {
+                    MessageBox.Show("工事基本情報明細、作成に失敗しました。", "コピー処理エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
 
                 return true;
             }
@@ -1113,10 +1187,24 @@
                 DB2.DeleteAction(strSQL, false);
                 DB3.DeleteAction(strSQL, false);
 
-                if (!DB1.RecordCopyAction(FromCode, ToCode, false)) return false;
-                if (!DB2.RecordCopyAction(FromCode, ToCode, false)) return false;
-                if (!DB3.RecordCopyAction(FromCode, ToCode, false)) return false;
+                if (!DB1.RecordCopyAction(FromCode, ToCode, false))
+                {
+                    MessageBox.Show("積算見積書データ、作成に失敗しました。", "コピー処理エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
 
+                if (!DB2.RecordCopyAction(FromCode, ToCode, false))
+                {
+                    MessageBox.Show("積算見積書ページデータ、作成に失敗しました。", "コピー処理エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
+                if (!DB3.RecordCopyAction(FromCode, ToCode, false))
+                {
+                    MessageBox.Show("積算見積書明細データ、作成に失敗しました。", "コピー処理エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
                 return true;
             }
             catch (Exception ex)
@@ -1169,5 +1257,40 @@
             }
         }
         #endregion
+
+        #region 工事リンク情報作成処理
+        /// <summary>
+        /// 工事リンク情報作成処理
+        /// </summary>
+        /// <returns></returns>
+        private bool CreateConstructionLink(int ToCode, IOConstructionLink DB7)
+        {
+            try
+            {
+                string strSQL = DB7.CreatePrimarykeyString(m_ConstructionCode, ToCode);
+                DB7.DeleteAction(strSQL, false);
+
+                // 増減工事の子データ以外はリンク情報を作成しない
+                if (m_BaseRec.TyingFlg != (int)CommonDefine.BaseInfoTyingFlg.Tying) return true;
+
+                ConstructionLink LinkRec = new ConstructionLink();
+                LinkRec.ConstructionCode = m_ConstructionCode;
+                LinkRec.FluctuationCode = ToCode;
+                LinkRec.LinkType = 0;
+
+                if (!DB7.InsertAction(LinkRec, false))
+                {
+                    MessageBox.Show("工事リンク情報、作成に失敗しました。", "コピー処理エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
     }
 }
Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/CostCalculation/FrmCostCalculationAuxiliary.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/CostCalculation/FrmCostCalculationAuxiliary.cs	(revision 82)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/CostCalculation/FrmCostCalculationAuxiliary.cs	(revision 83)
@@ -113,13 +113,20 @@
         #region 画面クリア
         private void ClearDisplay()
         {
-            txt1.Text = "0";
-            txt2.Text = m_Value1.ToString("#,0");
-            txt3.Text = m_Value2.ToString("#,0");
-            txt4.Text = m_Value3.ToString("#,0");
-            txt5.Text = DefultPercent[3].ToString("0.00");
+            try
+            {
+                txt1.Text = "0";
+                txt2.Text = m_Value1.ToString("#,0");
+                txt3.Text = m_Value2.ToString("#,0");
+                txt4.Text = m_Value3.ToString("#,0");
+                txt5.Text = DefultPercent[3].ToString("0.00");
 
-            LabelClear();
+                LabelClear();
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
         }
         #endregion
 
